• CodeForces1006F-Xor-Paths


    F. Xor-Paths

    time limit per test

    3 seconds

    memory limit per test

    256 megabytes

    input

    standard input

    output

    standard output

    There is a rectangular grid of size n×mn×m. Each cell has a number written on it; the number on the cell (i,ji,j) is ai,jai,j. Your task is to calculate the number of paths from the upper-left cell (1,11,1) to the bottom-right cell (n,mn,m) meeting the following constraints:

    • You can move to the right or to the bottom only. Formally, from the cell (i,ji,j) you may move to the cell (i,j+1i,j+1) or to the cell (i+1,ji+1,j). The target cell can't be outside of the grid.
    • The xor of all the numbers on the path from the cell (1,11,1) to the cell (n,mn,m) must be equal to kk (xor operation is the bitwise exclusive OR, it is represented as '^' in Java or C++ and "xor" in Pascal).

    Find the number of such paths in the given grid.

    Input

    The first line of the input contains three integers nn, mm and kk (1≤n,m≤201≤n,m≤20, 0≤k≤10180≤k≤1018) — the height and the width of the grid, and the number kk.

    The next nn lines contain mm integers each, the jj-th element in the ii-th line is ai,jai,j (0≤ai,j≤10180≤ai,j≤1018).

    Output

    Print one integer — the number of paths from (1,11,1) to (n,mn,m) with xor sum equal to kk.

    Examples

    input

    Copy

    3 3 11
    2 1 5
    7 10 0
    12 6 4
    

    output

    Copy

    3
    

    input

    Copy

    3 4 2
    1 3 3 3
    0 3 3 2
    3 0 1 1
    

    output

    Copy

    5
    

    input

    Copy

    3 4 1000000000000000000
    1 3 3 3
    0 3 3 2
    3 0 1 1
    

    output

    Copy

    0
    

    Note

    All the paths from the first example:

    • (1,1)→(2,1)→(3,1)→(3,2)→(3,3)(1,1)→(2,1)→(3,1)→(3,2)→(3,3);
    • (1,1)→(2,1)→(2,2)→(2,3)→(3,3)(1,1)→(2,1)→(2,2)→(2,3)→(3,3);
    • (1,1)→(1,2)→(2,2)→(3,2)→(3,3)(1,1)→(1,2)→(2,2)→(3,2)→(3,3).

    All the paths from the second example:

    • (1,1)→(2,1)→(3,1)→(3,2)→(3,3)→(3,4)(1,1)→(2,1)→(3,1)→(3,2)→(3,3)→(3,4);
    • (1,1)→(2,1)→(2,2)→(3,2)→(3,3)→(3,4)(1,1)→(2,1)→(2,2)→(3,2)→(3,3)→(3,4);
    • (1,1)→(2,1)→(2,2)→(2,3)→(2,4)→(3,4)(1,1)→(2,1)→(2,2)→(2,3)→(2,4)→(3,4);
    • (1,1)→(1,2)→(2,2)→(2,3)→(3,3)→(3,4)(1,1)→(1,2)→(2,2)→(2,3)→(3,3)→(3,4);
    • (1,1)→(1,2)→(1,3)→(2,3)→(3,3)→(3,4)(1,1)→(1,2)→(1,3)→(2,3)→(3,3)→(3,4).

    Codeforces (c) Copyright 2010-2018 Mike Mirzayanov

    The only programming contests Web 2.0 platform

    Server time: Jul/18/2018 00:56:41UTC+8 (d2).

    Desktop version, switch to mobile version.

    Privacy Policy

    题解:提议很好理解,寻找从(1,1)到(n,m)异或为K的路径有多少条;因为n,m<=20;暴力搜索即可DFS,可以双向DFS;

    AC代码为:

    #include <bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    int n, m;
    unordered_map<ll,ll> mp[21];
    ll ans, k, a[21][21];
    void dfs1(int i, int j, ll v)
    {
        v ^= a[i][j];
        if(i+j == n+1) 
        {
            ++mp[i][v]; 
            return ;
        } 
        if(i<n) dfs1(i+1, j,v);
        if(j<m) dfs1(i,j+1, v);
    }

    void dfs2(int i, int j, ll v)
    {
        if(i+j == n+1) 
        {
            ans += mp[i][v^k]; 
            return ;
        } 
        v ^= a[i][j];
        if(i > 1) dfs2(i-1, j, v);
        if(j > 1) dfs2(i, j-1, v);
    }

    int main()
    {
        ios::sync_with_stdio(false);
        cin.tie(0);
        cin>>n>>m>>k;
        for (int i = 1; i <= n; i++) 
        {
            for (int j = 1; j <= m; j++) cin>>a[i][j];
        } 
        dfs1(1,1,0); dfs2(n, m, 0);
        cout<<ans<<endl;
        return 0;
    }

  • 相关阅读:
    设计【SPFA】【差分约束】
    黑魔法师之门【并查集】
    太鼓达人【欧拉回路】【DFS】
    七夕祭【模拟】
    圣章精灵使的魔法语【线段树】
    终章剑之魂【模拟】【贪心】
    轻轨【线段树】【贪心】
    气象牛【DP】
    HTML属性
    HTML元素
  • 原文地址:https://www.cnblogs.com/csushl/p/9386774.html
Copyright © 2020-2023  润新知